#ifndef UTILS_H_
#define UTILS_H_

#include <unistd.h>
#include <termios.h>
#include <sys/ioctl.h>
#include <iostream>

namespace sc {

    class term {
        struct winsize _ws;
        std::ostream* _out {nullptr};

        public:
            term(int fd);

            int rows() const;
            int cols() const;

            void progress(double cur, double total) const;

            void hide_cursor() const;
            void show_cursor() const;
    };

    class cursor_hider {
        term _t;

        public:
            cursor_hider(int fd);
            ~cursor_hider();
    };

}

#endif // UTILS_H_
